#include <QtCore/qglobal.h>

#define YW60X_EXPORT Q_DECL_IMPORT
#define APIHEAD   int

#define byte unsigned char
#define BANK_RESERVE 0
#define BANK_EPC    1
#define BANK_TID    2
#define BANK_USER   3


class YW60X_EXPORT YW602
{
public:


    YW602();


    APIHEAD DES(unsigned char cModel, unsigned char *pkey, unsigned char *in, unsigned char *out);
    APIHEAD DES3(unsigned char cModel, unsigned char *pKey, unsigned char *pInData, unsigned char *pOutData);
    APIHEAD DES3_CBC(unsigned char cModel,  unsigned char *pKey,unsigned char *pInData, unsigned char *pOutData, unsigned char *pIV);


    APIHEAD YW_USBHIDInitial(void);

    APIHEAD YW_USBHIDFree(void);


    APIHEAD YW_SetReaderID(int OldID, int NewID);

    APIHEAD YW_GetReaderID(int ReaderID);

    APIHEAD YW_GetReaderVersion(int ReaderID);

    APIHEAD YW_GetReaderSerial(int ReaderID, char *ReaderSerial);

    APIHEAD YW_GetReaderNo(int ReaderID, char *ReadeNo);

    APIHEAD YW_Buzzer(int ReaderID,int Time_ON, int Time_OFF, int Cycle);

    APIHEAD YW_Led(int ReaderID,int LEDIndex, int Time_ON, int Time_OFF, int Cycle, int LedIndexOn);

    APIHEAD  YW_GetPower(int ReaderID);
    APIHEAD  YW_SetPower(int ReaderID, int Power);
    APIHEAD YW_GetInventoryThreshold(int ReaderID);
    APIHEAD YW_SetInventoryThreshold(int ReaderID, int Threshold);

    ////////////////////////////////////////////////////*******************G2 Start ***************************************/


    APIHEAD  YW_G2_Inventory(int ReaderID, bool GetEPC, int AddrTID, int LenTID, int *TagsNum, int *DataLen, unsigned char *EPC);

    APIHEAD  YW_G2_Read(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned char MemType, unsigned char StartPos, unsigned char ReadLen,
                    unsigned int Password,
                    int *G2DataLen, unsigned char *G2Data);

    APIHEAD  YW_G2_Write(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned char MemType, unsigned char StartPos,
                    unsigned int Password,
                    int G2DataLen, unsigned char *G2Data);

    APIHEAD  YW_G2_WriteEPC(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned int Password);

    APIHEAD  YW_G2_KillTag(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned int Password);

    APIHEAD  YW_G2_SetProtected(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned char Protect, unsigned char ProtectMode,
                    unsigned int Password);

    APIHEAD  YW_G2_Earse(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned char MemType, unsigned char StartPos,unsigned char Nums,
                    unsigned int Password);

    APIHEAD  YW_G2_SetReadProtectedWithEPC(int ReaderID, int EPCLen, unsigned char *EPC,
                    unsigned int Password);

    APIHEAD  YW_G2_SetReadProtected(int ReaderID, unsigned int Password);

    APIHEAD  YW_G2_SetUnlockReadProtected(int ReaderID, unsigned int Password);

    APIHEAD  YW_G2_TestReadProtected(int ReaderID, int *ReadProtected);

    APIHEAD  YW_G2_SetEASAlert(int ReaderID, int EPCLen, unsigned char *EPC,
                       unsigned int Password, unsigned char EAS);

    APIHEAD  YW_G2_TestEASAlert(int ReaderID, unsigned char *EAS);

    APIHEAD  YW_G2_LockUser(int ReaderID, int EPCLen, unsigned char *EPC,
                       unsigned int Password, unsigned char UserAddr);

    ///////////////**********G2 End**********************************//
};

