#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "libyw602.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    YW602 yoworfid;
    int ReaderID=1;
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private:
    QByteArray EPCNow;
    Ui::MainWindow *ui;
    void BeepOk();
    void BeepFail();
    QByteArrayList Inventory();
    void MsgBox(const QString &Content);
    QString HexToStr(unsigned char *Hex, unsigned char Len);
    int ConvertHexChar(char ch);
    int  StrToHexArray(const QString &Str, unsigned char *hex);
    QString ByteArrToStr(QByteArray &Hex);
public slots:
    void Click_OpenReader();
    void Click_CloseReader();
    void Click_Read();
    void Click_Write();
    void Click_Inven();
    void Click_GetVer();
    void Click_GetPower();
    void Click_SetPower();
    void Click_GetRSSI();
    void Click_SetRSSI();
    void Click_WriteEPC();
};
#endif // MAINWINDOW_H
